3 # resolve python-version to use
4 if [ "$PYTHON" == "" ] ; then
5 if which python >/dev/null 2>&1
8 elif which python2 >/dev/null 2>&1
11 elif which python2.7 >/dev/null 2>&1
15 echo "Unable to locate build-dependency python2.x!" 1>&2
20 # validate python-dependency
21 # useful in case of explicitly set option.
22 if ! which $PYTHON > /dev/null 2>&1
24 echo "Unable to locate build-dependency python2.x ($PYTHON)!" 1>&2
30 echo "Usage: $0 [BuildArch] [BuildType] [verbose] [coverage] [cross] [clangx.y] [ninja] [configureonly] [skipconfigure] [skipnative] [skipmscorlib] [skiptests] [cmakeargs] [bindir]"
31 echo "BuildArch can be: x64, x86, arm, arm-softfp, arm64"
32 echo "BuildType can be: debug, checked, release"
33 echo "coverage - optional argument to enable code coverage build (currently supported only for Linux and OSX)."
34 echo "ninja - target ninja instead of GNU make"
35 echo "clangx.y - optional argument to build using clang version x.y."
36 echo "cross - optional argument to signify cross compilation,"
37 echo " - will use ROOTFS_DIR environment variable if set."
38 echo "configureonly - do not perform any builds; just configure the build."
39 echo "skipconfigure - skip build configuration."
40 echo "skipnative - do not build native components."
41 echo "skipmscorlib - do not build mscorlib.dll."
42 echo "skiptests - skip the tests in the 'tests' subdirectory."
43 echo "skipnuget - skip building nuget packages."
44 echo "verbose - optional argument to enable verbose build output."
45 echo "-skiprestore: skip restoring packages ^(default: packages are restored during build^)."
46 echo "-disableoss: Disable Open Source Signing for System.Private.CoreLib."
47 echo "-sequential: force a non-parallel build ^(default is to build in parallel"
48 echo " using all processors^)."
49 echo "-officialbuildid=^<ID^>: specify the official build ID to be used by this build."
50 echo "-Rebuild: force a clean build ^(default is to perform an incremental build^)."
51 echo "skipgenerateversion - disable version generation even if MSBuild is supported."
52 echo "cmakeargs - user-settable additional arguments passed to CMake."
53 echo "bindir - output directory (defaults to $__ProjectRoot/bin)"
60 if [ "$__BuildOS" == "Linux" ]; then
61 if [ ! -e /etc/os-release ]; then
62 echo "WARNING: Can not determine runtime id for current distro."
65 source /etc/os-release
66 export __DistroRid="$ID.$VERSION_ID-$__HostArch"
73 echo Setting up directories for build
75 mkdir -p "$__RootBinDir"
78 mkdir -p "$__IntermediatesDir"
81 # Check the system to ensure the right prereqs are in place
85 echo "Checking prerequisites..."
87 # Check presence of CMake on the path
88 hash cmake 2>/dev/null || { echo >&2 "Please install cmake before running this script"; exit 1; }
91 hash clang-$__ClangMajorVersion.$__ClangMinorVersion 2>/dev/null || hash clang$__ClangMajorVersion$__ClangMinorVersion 2>/dev/null || hash clang 2>/dev/null || { echo >&2 "Please install clang-$__ClangMajorVersion.$__ClangMinorVersion before running this script"; exit 1; }
98 if [ $__SkipCoreCLR == 1 ]; then
99 echo "Skipping CoreCLR build."
103 # Event Logging Infrastructure
104 __GeneratedIntermediate="$__IntermediatesDir/Generated"
105 __GeneratedIntermediateEventProvider="$__GeneratedIntermediate/eventprovider_new"
106 if [[ -d "$__GeneratedIntermediateEventProvider" ]]; then
107 rm -rf "$__GeneratedIntermediateEventProvider"
110 if [[ ! -d "$__GeneratedIntermediate/eventprovider" ]]; then
111 mkdir -p "$__GeneratedIntermediate/eventprovider"
114 mkdir -p "$__GeneratedIntermediateEventProvider"
115 if [[ $__SkipCoreCLR == 0 || $__ConfigureOnly == 1 ]]; then
116 echo "Laying out dynamically generated files consumed by the build system "
117 echo "Laying out dynamically generated Event Logging Test files"
118 $PYTHON -B -Wall -Werror "$__ProjectRoot/src/scripts/genXplatEventing.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --exc "$__ProjectRoot/src/vm/ClrEtwAllMeta.lst" --testdir "$__GeneratedIntermediateEventProvider/tests"
120 if [[ $? != 0 ]]; then
124 #determine the logging system
127 echo "Laying out dynamically generated Event Logging Implementation of Lttng"
128 $PYTHON -B -Wall -Werror "$__ProjectRoot/src/scripts/genXplatLttng.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --intermediate "$__GeneratedIntermediateEventProvider"
129 if [[ $? != 0 ]]; then
138 echo "Cleaning the temp folder of dynamically generated Event Logging files"
139 $PYTHON -B -Wall -Werror -c "import sys;sys.path.insert(0,\"$__ProjectRoot/src/scripts\"); from Utilities import *;UpdateDirectory(\"$__GeneratedIntermediate/eventprovider\",\"$__GeneratedIntermediateEventProvider\")"
140 if [[ $? != 0 ]]; then
144 rm -rf "$__GeneratedIntermediateEventProvider"
146 # All set to commence the build
148 echo "Commencing build of native components for $__BuildOS.$__BuildArch.$__BuildType in $__IntermediatesDir"
153 if [ $__UseNinja == 1 ]; then
155 buildFile="build.ninja"
159 if [ $__SkipConfigure == 0 ]; then
160 # if msbuild is not supported, then set __SkipGenerateVersion to 1
161 if [ $__isMSBuildOnNETCoreSupported == 0 ]; then __SkipGenerateVersion=1; fi
162 # Drop version.c file
163 __versionSourceFile=$__IntermediatesDir/version.cpp
164 if [ $__SkipGenerateVersion == 0 ]; then
165 "$__ProjectRoot/run.sh" build -Project=$__ProjectDir/build.proj -generateHeaderUnix -NativeVersionSourceFile=$__versionSourceFile $__RunArgs $__UnprocessedBuildArgs
167 __versionSourceLine="static char sccsid[] __attribute__((used)) = \"@(#)No version information produced\";"
168 echo $__versionSourceLine > $__versionSourceFile
171 pushd "$__IntermediatesDir"
172 # Regenerate the CMake solution
173 echo "Invoking \"$__ProjectRoot/src/pal/tools/gen-buildsys-clang.sh\" \"$__ProjectRoot\" $__ClangMajorVersion $__ClangMinorVersion $__BuildArch $__BuildType $__CodeCoverage $__IncludeTests $generator $__cmakeargs"
174 "$__ProjectRoot/src/pal/tools/gen-buildsys-clang.sh" "$__ProjectRoot" $__ClangMajorVersion $__ClangMinorVersion $__BuildArch $__BuildType $__CodeCoverage $__IncludeTests $generator "$__cmakeargs"
178 # Check that the makefiles were created.
179 pushd "$__IntermediatesDir"
181 if [ ! -f "$__IntermediatesDir/$buildFile" ]; then
182 echo "Failed to generate native component build project!"
186 # Get the number of processors available to the scheduler
187 # Other techniques such as `nproc` only get the number of
188 # processors available to a single process.
189 if [ `uname` = "FreeBSD" ]; then
190 NumProc=`sysctl hw.ncpu | awk '{ print $2+1 }'`
191 elif [ `uname` = "NetBSD" ]; then
192 NumProc=$(($(getconf NPROCESSORS_ONLN)+1))
194 NumProc=$(($(getconf _NPROCESSORS_ONLN)+1))
199 echo "Executing $buildTool install -j $NumProc"
201 $buildTool install -j $NumProc
203 echo "Failed to build coreclr components."
209 isMSBuildOnNETCoreSupported()
211 # This needs to be updated alongwith corresponding changes to netci.groovy.
212 __isMSBuildOnNETCoreSupported=0
214 if [ "$__HostArch" == "x64" ]; then
215 if [ "$__HostOS" == "Linux" ]; then
216 case "$__DistroRid" in
218 __isMSBuildOnNETCoreSupported=1
221 __isMSBuildOnNETCoreSupported=1
224 __isMSBuildOnNETCoreSupported=1
227 __isMSBuildOnNETCoreSupported=1
230 __isMSBuildOnNETCoreSupported=1
233 __isMSBuildOnNETCoreSupported=1
236 __isMSBuildOnNETCoreSupported=1
240 elif [ "$__HostOS" == "OSX" ]; then
241 __isMSBuildOnNETCoreSupported=1
248 if [ $__SkipCoreCLR == 0 -a -e $__BinDir/crossgen ]; then
249 echo "Generating native image for System.Private.CoreLib."
250 $__BinDir/crossgen $__BinDir/System.Private.CoreLib.dll
251 if [ $? -ne 0 ]; then
252 echo "Failed to generate native image for System.Private.CoreLib."
256 echo "Generating native image for MScorlib Facade."
257 $__BinDir/crossgen $__BinDir/mscorlib.dll
258 if [ $? -ne 0 ]; then
259 echo "Failed to generate native image for mscorlib facade."
263 if [ "$__BuildOS" == "Linux" ]; then
264 echo "Generating symbol file for System.Private.CoreLib."
265 $__BinDir/crossgen /CreatePerfMap $__BinDir $__BinDir/System.Private.CoreLib.ni.dll
266 if [ $? -ne 0 ]; then
267 echo "Failed to generate symbol file for System.Private.CoreLib."
277 if [ $__isMSBuildOnNETCoreSupported == 0 ]; then
278 echo "System.Private.CoreLib.dll build unsupported."
282 if [ $__SkipMSCorLib == 1 ]; then
283 echo "Skipping building System.Private.CoreLib."
287 echo "Commencing build of managed components for $__BuildOS.$__BuildArch.$__BuildType"
290 $__ProjectRoot/run.sh build -Project=$__ProjectDir/build.proj -MsBuildLog="/flp:Verbosity=normal;LogFile=$__LogsDir/System.Private.CoreLib_$__BuildOS__$__BuildArch__$__BuildType.log" -BuildTarget -__IntermediatesDir=$__IntermediatesDir -__RootBinDir=$__RootBinDir -BuildNugetPackage=false -UseSharedCompilation=false $__RunArgs $__UnprocessedBuildArgs
292 if [ $? -ne 0 ]; then
293 echo "Failed to build managed components."
297 # The cross build generates a crossgen with the target architecture.
298 if [ $__CrossBuild != 1 ]; then
299 # The architecture of host pc must be same architecture with target.
300 if [[ ( "$__HostArch" == "$__BuildArch" ) ]]; then
302 elif [[ ( "$__HostArch" == "x64" ) && ( "$__BuildArch" == "x86" ) ]]; then
304 elif [[ ( "$__HostArch" == "arm64" ) && ( "$__BuildArch" == "arm" ) ]]; then
312 generate_NugetPackages()
314 # We can only generate nuget package if we also support building mscorlib as part of this build.
315 if [ $__isMSBuildOnNETCoreSupported == 0 ]; then
316 echo "Nuget package generation unsupported."
320 # Since we can build mscorlib for this OS, did we build the native components as well?
321 if [ $__SkipCoreCLR == 1 ]; then
322 echo "Unable to generate nuget packages since native components were not built."
326 echo "Generating nuget packages for "$__BuildOS
329 $__ProjectRoot/run.sh build -Project=$__SourceDir/.nuget/packages.builds -MsBuildLog="/flp:Verbosity=normal;LogFile=$__LogsDir/Nuget_$__BuildOS__$__BuildArch__$__BuildType.log" -BuildTarget -__IntermediatesDir=$__IntermediatesDir -__RootBinDir=$__RootBinDir -BuildNugetPackage=false -UseSharedCompilation=false $__RunArgs $__UnprocessedBuildArgs
331 if [ $? -ne 0 ]; then
332 echo "Failed to generate Nuget packages."
337 echo "Commencing CoreCLR Repo build"
339 # Argument types supported by this script:
341 # Build architecture - valid values are: x64, ARM.
342 # Build Type - valid values are: Debug, Checked, Release
344 # Set the default arguments for build
346 # Obtain the location of the bash script to figure out where the root of the repo is.
347 __ProjectRoot="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
349 # Use uname to determine what the CPU is.
351 # Some Linux platforms report unknown for platform, but the arch for machine.
352 if [ "$CPUName" == "unknown" ]; then
358 echo "Unsupported CPU $CPUName detected, build might not succeed!"
369 echo "Unsupported CPU $CPUName detected, build might not succeed!"
375 echo "Unsupported CPU $CPUName detected, build might not succeed!"
381 echo "Unknown CPU $CPUName detected, configuring as if for x64"
387 # Use uname to determine what the OS is.
421 echo "Unsupported OS $OSName detected, configuring as if for Linux"
429 __IncludeTests=Include_Tests
431 # Set the various build properties here so that CMake and MSBuild can pick them up
432 __ProjectDir="$__ProjectRoot"
433 __SourceDir="$__ProjectDir/src"
434 __PackagesDir="$__ProjectDir/packages"
435 __RootBinDir="$__ProjectDir/bin"
436 __UnprocessedBuildArgs=
448 __ClangMajorVersion=0
449 __ClangMinorVersion=0
450 __NuGetPath="$__PackagesDir/NuGet.exe"
453 __SkipGenerateVersion=0
456 if [ $# -le 0 ]; then
460 lowerI="$(echo $1 | awk '{print tolower($0)}')"
480 __BuildArch=arm-softfp
500 __CodeCoverage=Coverage
512 __ClangMajorVersion=3
513 __ClangMinorVersion=5
517 __ClangMajorVersion=3
518 __ClangMinorVersion=6
522 __ClangMajorVersion=3
523 __ClangMinorVersion=7
527 __ClangMajorVersion=3
528 __ClangMinorVersion=8
547 # Use "skipnative" to use the same option name as build.cmd.
552 # Accept "skipcoreclr" for backwards-compatibility.
561 __SkipGenerateVersion=1
580 echo "ERROR: 'cmakeargs' requires a non-empty option argument"
588 if [ ! -d $__RootBinDir ]; then
591 __RootBinParent=$(dirname $__RootBinDir)
592 __RootBinName=${__RootBinDir##*/}
593 __RootBinDir="$(cd $__RootBinParent &>/dev/null && printf %s/%s $PWD $__RootBinName)"
596 echo "ERROR: 'bindir' requires a non-empty option argument"
602 __UnprocessedBuildArgs="$__UnprocessedBuildArgs $1"
609 __RunArgs="-BuildArch=$__BuildArch -BuildType=$__BuildType -BuildOS=$__BuildOS"
611 # Configure environment if we are doing a verbose build
612 if [ $__VerboseBuild == 1 ]; then
614 __RunArgs="$__RunArgs -verbose"
617 # Set default clang version
618 if [[ $__ClangMajorVersion == 0 && $__ClangMinorVersion == 0 ]]; then
619 if [ $__CrossBuild == 1 ]; then
620 __ClangMajorVersion=3
621 __ClangMinorVersion=6
623 __ClangMajorVersion=3
624 __ClangMinorVersion=5
628 # Set dependent variables
629 __LogsDir="$__RootBinDir/Logs"
631 # init the distro name
634 # Set the remaining variables based upon the determined build configuration
635 __BinDir="$__RootBinDir/Product/$__BuildOS.$__BuildArch.$__BuildType"
636 __PackagesBinDir="$__BinDir/.nuget"
637 __ToolsDir="$__RootBinDir/tools"
638 __TestWorkingDir="$__RootBinDir/tests/$__BuildOS.$__BuildArch.$__BuildType"
639 export __IntermediatesDir="$__RootBinDir/obj/$__BuildOS.$__BuildArch.$__BuildType"
640 __TestIntermediatesDir="$__RootBinDir/tests/obj/$__BuildOS.$__BuildArch.$__BuildType"
641 __isMSBuildOnNETCoreSupported=0
643 # Init if MSBuild for .NET Core is supported for this platform
644 isMSBuildOnNETCoreSupported
646 # CI_SPECIFIC - On CI machines, $HOME may not be set. In such a case, create a subfolder and set the variable to set.
647 # This is needed by CLI to function.
648 if [ -z "$HOME" ]; then
649 if [ ! -d "$__ProjectDir/temp_home" ]; then
652 export HOME=$__ProjectDir/temp_home
653 echo "HOME not defined; setting it to $HOME"
656 # Specify path to be set for CMAKE_INSTALL_PREFIX.
657 # This is where all built CoreClr libraries will copied to.
658 export __CMakeBinDir="$__BinDir"
660 # Configure environment if we are doing a cross compile.
661 if [ $__CrossBuild == 1 ]; then
662 export CROSSCOMPILE=1
663 if ! [[ -n "$ROOTFS_DIR" ]]; then
664 export ROOTFS_DIR="$__ProjectRoot/cross/rootfs/$__BuildArch"
668 # Make the directories necessary for build if they don't exist
676 # Build the coreclr (native) components.
680 # Build System.Private.CoreLib.
684 # Generate nuget packages
685 if [ $__SkipNuget != 1 ]; then
686 generate_NugetPackages
692 echo "Repo successfully built."
693 echo "Product binaries are available at $__BinDir"